<template>
  <div>
    <status-indicator-tag
      @click="modals.show('picker', $event)"
      class="text-sm"
      v-if="task.isDeadlined && !task.isDone()"
      :status="task.isToday() ? 'emphasized' : task.isOverdue() ? 'negative' : 'deemphasized'"
    >
      <i :class="`hero flag solid mr-2`"></i>
      <div>
        {{ task.deadlineAt.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
      </div>
    </status-indicator-tag>
    <status-indicator-tag v-else class="rounded-l-none" @click="modals.show('picker', $event)">
      <i class="hero flag outline"></i>
    </status-indicator-tag>
    <modal :is="modals.get('picker')" :task="task" />
  </div>
</template>

<script lang="ts">
import Picker from "./TaskDeadlinedPicker.vue";
import { useModals } from "@/use/modal";
import Task from "@/models/Task";
import Tag from "@/components/Tag.vue";
import StatusIndicatorTag from "../StatusIndicatorTag.vue";

export default {
  components: { Tag, StatusIndicatorTag },
  props: {
    task: {
      type: Task,
      required: true
    }
  },
  setup(props) {
    return {
      modals: useModals({ Picker })
    };
  }
};
</script>
